package lt.bit.SauktiniuSarasas.restControllers;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.springframework.boot.test.context.SpringBootTest;

import lt.bit.SauktiniuSarasas.Exeptions.SauktinisException;
import lt.bit.SauktiniuSarasas.entities.Sauktinis;
import lt.bit.SauktiniuSarasas.services.SauktiniaiService;

@SpringBootTest
class SauktiniaiControllerTest {
	@Mock
	SauktiniaiService sauktiniaiService;
	
	@InjectMocks
	SauktiniaiController controller;
	
	

	@BeforeEach
	void setUp() throws Exception {
	}

	@Test
	void successAddMethodReturnsSauktinisObject(){
		Sauktinis s=new Sauktinis("Jonas", "Jonaitis", "+370670212", "jonas@jonas.lt", 19);
		Sauktinis g=new Sauktinis("Jonas", "Jonaitis", "+370670212", "jonas@jonas.lt", 19);
		g.setId(1);
		
		when(sauktiniaiService.getByEmail(s.getEmail())).thenReturn(null);
		when(sauktiniaiService.saveSauktinis(s)).thenReturn(g);
		Sauktinis sS=controller.add(s);
		
		assertEquals(s, sS);
		verify(sauktiniaiService).getByEmail(s.getEmail());
		verify(sauktiniaiService).saveSauktinis(s);
		 
	}
	
	@Test
	void ifEmailIsUsedShouldThrowSauktinisException() {
		Sauktinis s=new Sauktinis("Jonas", "Jonaitis", "+370670212", "jonas@jonas.lt", 19);
		when(sauktiniaiService.getByEmail(s.getEmail())).thenReturn(s);
		when(sauktiniaiService.saveSauktinis(s)).thenReturn(s);
		
		assertThrows(SauktinisException.class, ()->{
			Sauktinis sS=controller.add(s);
		});
		verify(sauktiniaiService).getByEmail(s.getEmail());
		verify(sauktiniaiService,times(0)).saveSauktinis(s);
	}

}
